Subject: bug#23785: Emacs 25: 'Undo' overdoes things.

From: Stefan Monnier <[email-masked]>
Date: Sun, 19 Jun 2016 20:59:33 -0400

> The other fiddles with insert-file-contents and adds an undo. It is this
> function that has specialized handling for the undo list that is causing
> the problem. My patch in this case is questionable in that I have randomly
> pushed a call to undo-boundary near the end. It should probably be
> somewere better.

Indeed, the problem is not that insert-file-contents fails to add
a boundary, but rather that it removes an existing one, so we should
figure out where/why it removes it and change the code to push one back
after removing it.

> Another possibility would be to have insert-file-contents call
> "undo-auto--undoable-change" -- this is the root cause of the problem.

Figuring out why undo-auto--undoable-change isn't called for it would be
good as well, indeed.  After all, it runs after-change-functions, so
it should call undo-auto--undoable-change.

        Stefan